"use strict";
this.name = "Smugglers_IllegalMarket";
this.author = "phkb";
this.description = "Applies illegal goods data to GalCop stations.";
this.licence = "CC BY-NC-SA 3.0";

/*
Special Notes:
In order for the market script to work out when is the right time to populate data, I'm monitoring the clock.
As soon as a fractional component appears we can be pretty sure enough of the system has been loaded (either via a saved game or after initialising a new game)
for the "smugglers_illegal.js" script to do it's work successfully.
I've tested this methodology against the standard start options and with the "start choices" OXP and it appears to work OK.
*/

//-------------------------------------------------------------------------------------------------------------
this.updateGeneralCommodityDefinition = function (goodDefinition, station, systemID) {

	var si = worldScripts.Smugglers_Illegal;

	if (si && (station === 0 || station == null || (station && station.allegiance === "galcop"))) {
		// if there are factional seconds we can assume enough of the game have been loaded in order to populate the illegal goods definitions
		if (si._dataLoaded === false && parseInt((clock.seconds % 1) * 10000) != 0) {
			si.$initialiseData();
		}

		if (si._dataLoaded === true) {
			// does this system have any commodities that need adjusting?
			var sysID = systemID;
			if (sysID === -1) {
				// get the players witchspace destination
				if (si._witchspaceDestination != -1) {
					sysID = si._witchspaceDestination;
				} else {
					// work out the next system from the players route
					var p = player.ship;
					var target = p.targetSystem;
					var myRoute = System.infoForSystem(galaxyNumber, si._originating).routeToSystem(System.infoForSystem(galaxyNumber, target), p.routeMode);
					sysID = myRoute.route[1];
				}
			}

			var goods = si.$illegalGoodsList(sysID);
			for (var i = 0; i < goods.length; i++) {
				// each item in goods can have multiple commodities listed, so see if goodDefinition.key is contained in the commodity list of goods
				if (goods[i].commodity.indexOf(goodDefinition.key) >= 0) {
					// we have a winner, so adjust the legality property
					goodDefinition.legality_import = goods[i].scale;
					// prices will be changed via the Smugglers_Illegal.$updateSystemPrices routine 
				}
			}
		}
	}

	return goodDefinition;
}